# Kafka

Commands :
Run these commands  from root folder .
Run zookeeper:
.\bin\windows\zookeeper-server-start.bat .\config\zookeeper.properties

Run Kafka server
.\bin\windows\kafka-server-start.bat .\config\server.properties

Create a topic:
.\bin\windows\kafka-topics.bat --create --topic first_topic --bootstrap-server localhost:9092

Run Producer:
.\bin\windows\kafka-console-producer.bat --topic first_topic --bootstrap-server localhost:9092
-
Run Consumer:
.\bin\windows\kafka-console-consumer.bat --topic third --from-beginning --bootstrap-server localhost:9092

Check all topis:
.\bin\windows\kafka-topics.bat --zookeeper localhost:2181 --list


mvn clean install -DskipTests
cd src/main/resources/docker
docker-compose -f kafka-docker-compose.yml up -d (to run kafka and zookeeper servers)
docker-compose -f kafka-docker-compose.yml ps (to know about the status)
docker exec it name bash (to go particular specific point)

kafka-console-producer --bootstrap-server localhost:9092 --topic topic_name stock-live
kafka-console-consumer --bootstrap-server localhost:9092 --topic adult stock-live


docker run -p 61616:61616 -p 8161:8161 rmohr/activemq




Docker :
   To fix environment compatibility errors we can setup docker files
   and we can compose docker container if we want more than one container
   

version: '2'

services:
  zookeeper:
    image: docker.io/bitnami/zookeeper:3-debian-10
    ports:
      - '2181:2181'
    volumes:
      - 'zookeeper_data:/bitnami'
    environment:
      - ALLOW_ANONYMOUS_LOGIN=yes
  kafka:
    image: docker.io/bitnami/kafka:2-debian-10
    hostname: localhost
    ports:
      - '9092:9092'
    volumes:
      - 'kafka_data:/bitnami'
    environment:
      - KAFKA_CFG_ZOOKEEPER_CONNECT=zookeeper:2181
      - ALLOW_PLAINTEXT_LISTENER=yes
    depends_on:
      - zookeeper
volumes:
  zookeeper_data:
    driver: local
  kafka_data:
    driver: local

kafka-producer:
    container_name: kafka-producer
    image: docker.io/bitnami/kafka:2-debian-10
    build:
     context:
    working_dir: /kafka
    entrypoint: /bin/bash
    stdin_open: true
    tty: true


create docker-image for springboot:
------------------------------
docker build -f dockerFileName -t customeImageName .
docker images (to see what all images are there)

